#line 55 "C:\iccv7avr\include\macros.h"
void _StackCheck(void);
void _StackOverflowed(char);

#line 36 "C:\DOCUME~1\Steve\Desktop\Billys_files\docs\SMARTL~1\SMARTL~1\SmartLCD\SMARTL~1\USI_TWI_Slave.h"
void TWI_Slave_Initialise(unsigned char);
unsigned char TWI_Start_Transceiver_With_Data(unsigned char *,
 unsigned char );
unsigned char TWI_Get_Data_From_Transceiver(unsigned char *,
 unsigned char );











struct TWI_S_statusReg {
 unsigned dataInTxBuf:1;
 unsigned dataInRxBuf:1;
 unsigned genAddressCall:1; 
 unsigned RxBufOverflow:1;
 unsigned TxBufOverflow:1;
 unsigned unused:3;
 } ;

struct TWI_S_statusReg TWI_statusReg ;

#line 33 "C:\DOCUME~1\Steve\Desktop\Billys_files\docs\SMARTL~1\SMARTL~1\SmartLCD\SMARTL~1\USI_TWI_Slave.c"
static unsigned char TWI_slaveAddress;

static unsigned char TWI_RxBuf[6];
static unsigned char TWI_TxBuf[6];


struct USI_TWI_S_statusReg USI_TWI_statusReg = {0};


struct USI_TWI_state 
{
 unsigned addressMode:1;

 unsigned masterReadDataMode:1; 
 unsigned unused:6;
} USI_TWI_state = {0};

extern unsigned char isrtrigger,isrcnt;








void USI_TWI_Slave_Initialise(unsigned char TWI_ownAddress)
{
 TWI_slaveAddress = TWI_ownAddress;

 (*(volatile unsigned char *)0x25) |= (1<<2); 
 (*(volatile unsigned char *)0x25) |= (1<<0); 
 (*(volatile unsigned char *)0x24) |= (1<<2); 

 (*(volatile unsigned char *)0x24) &= ~(1<<0); 





 USICR = (1<<USISIE)|(0<<USIOIE)| 
 (1<<USIWM1)|(0<<USIWM0)| 
 (1<<USICS1)|(0<<USICS0)|(0<<USICLK)| 
 (0<<USITC);

 USISR = 0xF0; 
}




unsigned char USI_TWI_Start_Transceiver_With_Data(unsigned char *msg,
 unsigned char msgSize)
{
 unsigned char i;






 if(!USI_TWI_statusReg.dataInTxBuf) {
 for(i=0; i<msgSize; i++)
 TWI_TxBuf[i] = msg[i];
 USI_TWI_statusReg.dataInTxBuf = 1;
 return (1);
 }
 else
 return (0);
}


unsigned char USI_TWI_Get_Data_From_Transceiver(unsigned char *msg,
 unsigned char msgSize)
{
 unsigned char i;






 if(USI_TWI_statusReg.dataInRxBuf) {
 for(i=0; i<msgSize; i++)
 msg[i] = TWI_RxBuf[i];
 USI_TWI_statusReg.dataInRxBuf = 0;
 return (1);
 }
 else
 return (0);
}







void USI_Start_Condition_ISR(void)
{ 


 USI_TWI_state.addressMode = 1; 
 (*(volatile unsigned char *)0x24) &= ~(1<<0); 


 while((*(volatile unsigned char *)0x23)&(1<<2)) ; 






 USICR = (1<<USISIE)|(1<<USIOIE)| 
 (1<<USIWM1)|(1<<USIWM0)| 
 (1<<USICS1)|(0<<USICS0)|(0<<USICLK)| 
 (0<<USITC);




 USISR = (1<<USISIF)|(1<<USIOIF)|(1<<USIPF)|(1<<USIDC)| 
 (0x0<<USICNT0); 
}






void USI_Counter_Overflow_ISR(void)
{
 static volatile unsigned char TWI_bufPtr;





 if(USI_TWI_state.addressMode) { 



 if((USIDR==0) || ((USIDR>>1)==TWI_slaveAddress)) {

 TWI_bufPtr = 0; 
 if(USIDR == 0) USI_TWI_statusReg.genAddressCall = 1;
 else USI_TWI_statusReg.genAddressCall = 0;


 USI_TWI_state.addressMode = 0; 

 USI_TWI_state.masterReadDataMode = (USIDR & 0x01); 

 TWI_RxBuf[TWI_bufPtr++] = (USIDR & 0x01);

 USIDR = 0; 

 if(USI_TWI_state.masterReadDataMode) {



 if(!USI_TWI_statusReg.dataInTxBuf) {




 USICR = (1<<USISIE)|(0<<USIOIE)| 
 (1<<USIWM1)|(0<<USIWM0)| 
 (1<<USICS1)|(0<<USICS0)|(0<<USICLK)| 
 (0<<USITC);

 USISR = (0<<USISIF)| 
 (1<<USIOIF)|
 (1<<USIPF)|
 (1<<USIDC)| 
 (0x0<<USICNT0);
 return;
 }
 }



 else if(USI_TWI_statusReg.dataInRxBuf) {



 USICR = (1<<USISIE)|(0<<USIOIE)| 
 (1<<USIWM1)|(0<<USIWM0)| 
 (1<<USICS1)|(0<<USICS0)|(0<<USICLK)| 
 (0<<USITC);

 USISR = (0<<USISIF)| 
 (1<<USIOIF)|
 (1<<USIPF)|
 (1<<USIDC)| 
 (0x0<<USICNT0);
 return;
 }



 USIDR = 0;
 (*(volatile unsigned char *)0x24) |= (1<<0); 


 USISR = (0<<USISIF)|(1<<USIOIF)|(1<<USIPF)|(1<<USIDC)| 
 (0xE<<USICNT0); 

 while(!(USISR & ( (1<<USISIF)|(1<<USIOIF)))); 
 (*(volatile unsigned char *)0x24) &= ~(1<<0); 
 }



 else { 




 USICR = (1<<USISIE)|(0<<USIOIE)| 
 (1<<USIWM1)|(0<<USIWM0)| 
 (1<<USICS1)|(0<<USICS0)|(0<<USICLK)| 
 (0<<USITC);

 USISR = (0<<USISIF)| 
 (1<<USIOIF)|
 (1<<USIPF)|
 (1<<USIDC)| 
 (0x0<<USICNT0);
 return;
 }
 }



 else {


 if(USI_TWI_state.masterReadDataMode) {
 (*(volatile unsigned char *)0x24) &= ~(1<<0); 
 USIDR = 0;


 USISR = (0<<USISIF)|(1<<USIOIF)|(1<<USIPF)|(1<<USIDC)| 
 (0xE<<USICNT0);

 while(!(USISR & ((1<<USISIF)|(1<<USIOIF)))); 

 if(USIDR) {
 USI_TWI_statusReg.dataInTxBuf = 0;



 USICR = (1<<USISIE)|(0<<USIOIE)| 
 (1<<USIWM1)|(0<<USIWM0)| 
 (1<<USICS1)|(0<<USICS0)|(0<<USICLK)| 
 (0<<USITC);

 USISR = (0<<USISIF)| 
 (1<<USIOIF)|
 (1<<USIPF)|
 (1<<USIDC)| 
 (0x0<<USICNT0);
 return;
 }




























 }



 else {
 TWI_RxBuf[TWI_bufPtr++] = USIDR;
 USIDR = 0; 








 (*(volatile unsigned char *)0x24) |= (1<<0); 


 USISR = (0<<USISIF)|(1<<USIOIF)|(1<<USIPF)|(1<<USIDC)| 
 (0xE<<USICNT0); 

 while(!(USISR & ( (1<<USISIF)|(1<<USIOIF)))); 
 (*(volatile unsigned char *)0x24) &= ~(1<<0); 
 }
 }



 if(USI_TWI_state.masterReadDataMode) {

 USIDR = TWI_TxBuf[TWI_bufPtr++]; 
 (*(volatile unsigned char *)0x24) |= (1<<0); 


 USISR = (0<<USISIF)|(1<<USIOIF)|(1<<USIPF)|(1<<USIDC)| 
 (0x0<<USICNT0); 
 }



 else {




 USISR = (0<<USISIF)|(1<<USIOIF)|(1<<USIPF)|(1<<USIDC)| 
 (0xE<<USICNT0); 

 while(!(USISR & ((1<<USISIF)|(1<<USIOIF)|(1<<USIPF)))); 


 if(USISR & (1<<USIPF)) {

 USI_TWI_statusReg.dataInRxBuf = 1;

 TWI_RxBuf[0] = TWI_RxBuf[0] | ((TWI_bufPtr-1)<<4);





 USICR = (1<<USISIE)|(0<<USIOIE)| 
 (1<<USIWM1)|(0<<USIWM0)| 
 (1<<USICS1)|(0<<USICS0)|(0<<USICLK)| 
 (0<<USITC);

 USISR = (0<<USISIF)| 
 (1<<USIOIF)|
 (1<<USIPF)|
 (1<<USIDC)| 
 (0x0<<USICNT0);
 return;
 }
 else {


 USISR = (0<<USISIF)|(1<<USIOIF)|(0<<USIPF)|(1<<USIDC)| 
 (0x2<<USICNT0); 
 }
 }
}
